package com.ruoyi.project.sems.service.impl;

import java.io.IOException;
import java.time.LocalDate;
import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.file.FileUploadUtils;
import com.ruoyi.framework.config.RuoYiConfig;
import com.ruoyi.project.common.domain.TCommonfile;
import com.ruoyi.project.common.mapper.TCommonfileMapper;
import com.ruoyi.project.sems.domain.DevData;
import com.ruoyi.project.sems.domain.TSpecdevYlgd;
import com.ruoyi.project.sems.his.domain.TSpechiDzsb;
import org.springframework.stereotype.Service;
import com.ruoyi.project.sems.mapper.TSpecdevDzsbMapper;
import com.ruoyi.project.sems.domain.TSpecdevDzsb;
import com.ruoyi.project.sems.service.ITSpecdevDzsbService;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;

/**
 * 特种设备吊装设备台账Service业务层处理
 *
 * @author ruoyi
 * @date 2021-07-26
 */
@Service("tSpecdevDzsbService")
public class TSpecdevDzsbServiceImpl extends ServiceImpl<TSpecdevDzsbMapper, TSpecdevDzsb> implements ITSpecdevDzsbService
{
    @Resource
    private TSpecdevDzsbMapper tSpecdevDzsbMapper;
    @Resource
    private TCommonfileMapper tCommonfileMapper;
    /**
     * 查询特种设备吊装设备台账
     *
     * @param id 特种设备吊装设备台账ID
     * @return 特种设备吊装设备台账
     */
    @Override
    public TSpecdevDzsb selectTSpecdevDzsbById(Long id)
    {
        return tSpecdevDzsbMapper.selectTSpecdevDzsbById(id);
    }

    /**
     * 查询特种设备吊装设备台账列表
     *
     * @param tSpecdevDzsb 特种设备吊装设备台账
     * @return 特种设备吊装设备台账
     */
    @Override
    public List<TSpecdevDzsb> selectTSpecdevDzsbList(TSpecdevDzsb tSpecdevDzsb)
    {
        return tSpecdevDzsbMapper.selectTSpecdevDzsbList(tSpecdevDzsb);
    }

    @Override
    public List<TSpecdevDzsb> selectTSpecdevDzsbListByYear(TSpecdevDzsb tSpecdevDzsb) {
        return tSpecdevDzsbMapper.selectTSpecdevDzsbListByYear(tSpecdevDzsb);
    }

    /**
     * 新增特种设备吊装设备台账
     *
     * @param tSpecdevDzsb 特种设备吊装设备台账
     * @return 结果
     */
    @Override
    public int insertTSpecdevDzsb(TSpecdevDzsb tSpecdevDzsb)
    {
        return tSpecdevDzsbMapper.insertTSpecdevDzsb(tSpecdevDzsb);
    }

    /**
     * 修改特种设备吊装设备台账
     *
     * @param tSpecdevDzsb 特种设备吊装设备台账
     * @return 结果
     */
    @Override
    public int updateTSpecdevDzsb(TSpecdevDzsb tSpecdevDzsb)
    {
        return tSpecdevDzsbMapper.updateTSpecdevDzsb(tSpecdevDzsb);
    }

    /**
     * 批量删除特种设备吊装设备台账
     *
     * @param ids 需要删除的特种设备吊装设备台账ID
     * @return 结果
     */
    @Override
    public int deleteTSpecdevDzsbByIds(Long[] ids)
    {
        return tSpecdevDzsbMapper.deleteTSpecdevDzsbByIds(ids);
    }

    /**
     * 删除特种设备吊装设备台账信息
     *
     * @param id 特种设备吊装设备台账ID
     * @return 结果
     */
    @Override
    public int deleteTSpecdevDzsbById(Long id)
    {
        return tSpecdevDzsbMapper.deleteTSpecdevDzsbById(id);
    }

    @Override
    public List<DevData> otherDevCount(Map<String, Object> params) {
        return tSpecdevDzsbMapper.otherDevCount(params);
    }

    @Override
    public int updateTSpecdevDzsbByHi(TSpechiDzsb hientity) {
        return tSpecdevDzsbMapper.updateTSpecdevDzsbByHi(hientity);
    }

    @Override
    public void duplicateTSpecdevDzsb() {
        tSpecdevDzsbMapper.duplicateTSpecdevDzsb();
    }

    @Override
    @Transactional
    public int importFiles(List<MultipartFile> files, String plantCode, String fileType , String userId) throws Exception {
        for (MultipartFile file : files) {
            if (!file.isEmpty()) {
                String input = file.getOriginalFilename();
                int index = input.indexOf('_');
                String weiHao = (index != -1) ? input.substring(0, index) : input;
                System.out.println(weiHao); // 输出: 位号
                TSpecdevDzsb param = new TSpecdevDzsb();
                param.setDevno(weiHao);
                param.setPlantCode(plantCode);
                List<TSpecdevDzsb> list = tSpecdevDzsbMapper.selectTSpecdevDzsbListByDevNo(param);
                if (list.size() > 0) {
                    for (TSpecdevDzsb t: list
                    ) {
                        Long id = t.getId();
                        // 获取当前日期
                        LocalDate currentDate = LocalDate.now();
                        // 获取年份
                        int year = currentDate.getYear();
                        String dir = "/sems-dzsb-" + fileType + "/" + year;
                        String url = null;
                        try {
                            url = FileUploadUtils.upload(RuoYiConfig.getFilePath(dir), file);
                        } catch (IOException e) {
                            e.printStackTrace();
                        }
                        long size = file.getSize()/1024;
                        TCommonfile tCommonfile = new TCommonfile();
                        tCommonfile.setFileUrl(url);
                        tCommonfile.setFileName(file.getOriginalFilename());
                        tCommonfile.setCreaterCode(userId);
                        tCommonfile.setpId(id);
                        tCommonfile.setpType("sems-dzsb-"+fileType);
                        tCommonfile.setFileSize(String.valueOf(size));
                        tCommonfileMapper.insertTCommonfile(tCommonfile);
                    }
                }else {
                    throw new Exception( StringUtils.format(input +":无法找到对应设备"));
                }
            }
        }
        return 1;
    }
}
